<?php

namespace CreoCode\ContaoFormSubmissions;
use Contao\DataContainer;
use Contao\Database;

use CreoCode\ContaoFormSubmissions\FormSubmissionsSetModel;
use CreoCode\ContaoFormSubmissions\FormSubmissionsModel;
use CreoCode\ContaoFormSubmissions\FormSubmissionsDataModel;


/**
 * Class FormSubmissions
 */
class FormSubmissions extends \Frontend {

    /**
     * Save form submission
     */
    public function saveSubmission($arrPost, $arrFormDCA, $arrFiles) {
        // check if option is activated
        if (empty($arrFormDCA['cc_save_submissions'])) {
            return;
        }

        // create new set if none found
        $set = FormSubmissionsSetModel::findOneBy('form_id', $arrFormDCA['id']);
        if (empty($set)) {
            // form not found, create a new set
            $set = new FormSubmissionsSetModel();
            $set->form_id = $arrFormDCA['id'];
            $set->form_alias = $arrFormDCA['alias'];
            $set->form_title = $arrFormDCA['title'];

            $set->tstamp = time();
            $set->save();
        }

        // Save Form
        $item = new FormSubmissionsModel();

        $item->pid = $set->current()->id;
        $item->tstamp = time();
        $item->recipient = $arrFormDCA['recipient'];

        $item->save();

        // Save Form Data
        $itemData = new FormSubmissionsDataModel();

        // prepare field names allowed in this form
        // hacky solution to filter out the session form values 
        // from previously submitted forms and service fileds, hashes, tokens etc
        $objFormFields = \FormFieldModel::findBy('pid', $arrFormDCA['id']);
        $arrFormFields = $objFormFields->fetchEach('name');

        $strData = '<ul>';
        // format form data
        foreach ($arrPost as $key => $value) {
            if (array_search($key, $arrFormFields)) {
                // handle optional values if they are empty
                if (empty($value)) {
                    $value = '-';
                }
                // convert array values to comma separated strings
                if (is_array($value)) {
                    $value = implode(', ', $value);                    
                }
                $strData .= '<li><strong>' . htmlspecialchars($key) . '</strong>: ' . htmlspecialchars($value) . '</li>';
            }
        }
        $strData .= '</ul>';

        $itemData->pid = $item->id;
        $itemData->form_id = $arrFormDCA['id'];
        $itemData->tstamp = time();
        $itemData->data = $strData;

        $itemData->save();
        
    }

}
